#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <winsock2.h>
#include <MSWSock.h>

#include "vl.h"
#include "types.h"

extern enum debug_flags my_debug_flags;
extern struct config_t config;

int do_regular_send(
	IN	SOCKET socket,
	IN	char* buf,
	IN	int len,
	IN	int flags)
{
	int sent = 0;
	int rc;

	do { // this might be a problem if other side decides to complete before this finishes sending !!!!!!!!
		rc = send(socket, buf + sent, len - sent, flags);
		CHECK_NOT_EQUAL("send", rc, SOCKET_ERROR, return -1);
		sent += rc;
	} while(sent < len);

	return 0;
}

int client_main(
	IN	struct VL_random_t *rand_t)
{
	struct sockaddr_in		serv_addr;
	struct in_addr			remote_addr;
	SOCKET				*socket_array = NULL;
	char				*buf = NULL;
	int				num_sends_per_port = (config.num_connections / config.num_outs_connections) * config.num_outs_connections;
	int				i;
	int				j;
	int				result = -1;
	int				rc;

	
	socket_array = malloc(config.num_outs_connections * config.num_ports * sizeof(SOCKET));
	CHECK_NOT_EQUAL("malloc", socket_array, NULL, goto cleanup);

	memset(socket_array, 0, config.num_outs_connections * config.num_ports * sizeof(SOCKET));

	buf = malloc(config.num_outs_connections * config.num_ports * config.message_size);
	CHECK_NOT_EQUAL("malloc", buf, NULL, goto cleanup);

	remote_addr.S_un.S_addr = inet_addr(config.ip);
	CHECK_NOT_EQUAL("inet_addr", remote_addr.S_un.S_addr, INADDR_NONE, goto cleanup);

	serv_addr.sin_addr = remote_addr;      
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_port = htons((u_short)config.portnum);

	for (i = 0; i < config.num_outs_connections * config.num_ports; ++i)
		set_buffer_data(buf +  i * config.message_size, config.message_size, i % config.num_ports);

	for (j = 0; j < num_sends_per_port; j += config.num_outs_connections) {
		for (i = 0; i < config.num_outs_connections * config.num_ports; ++i) {
			if (socket_array[i]) {
				rc = closesocket(socket_array[i]);
				CHECK_VALUE("closesocket", rc, 0, goto cleanup);

				socket_array[i] = 0;
			}

			socket_array[i] = socket(AF_INET, SOCK_STREAM, 0);
			CHECK_NOT_EQUAL("socket", socket_array[i], INVALID_SOCKET, goto cleanup);

			serv_addr.sin_port = htons((u_short)config.portnum + (i % config.num_ports));

			rc = connect(socket_array[i], (struct sockaddr*)&serv_addr, sizeof(serv_addr));
			CHECK_NOT_EQUAL("connect", rc, SOCKET_ERROR, printf("i %d j %d\n", i, j); goto cleanup);

			rc = do_regular_send(socket_array[i], buf + i * config.message_size, config.message_size, 0);
			CHECK_VALUE("do_regular_send", rc, 0, goto cleanup);
		}
	}
	
	result = 0;
cleanup:
	
	if (socket_array) {
		for (i = 0; i < config.num_outs_connections * config.num_ports; ++i) {
			if (socket_array[i]) {
				rc = closesocket(socket_array[i]);
				CHECK_NOT_EQUAL("closesocket", rc, SOCKET_ERROR, result = -1; break);
			}
		}
		free(socket_array);
	}

	if (buf)
		free(buf);

	return result;
}