#include <winsock2.h>
#include "vl.h"
#include "types.h"

#define CASE_SETSTR(e)  case e: s = #e; break;
static const char *UnKnown = "UnKnown";

void ErrorExit(
	IN	const char *funct) 
{ 
	LPVOID lpMsgBuf;
	DWORD dw = GetLastError(); 

	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		dw,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR) &lpMsgBuf,
		0, NULL );

	VL_MISC_ERR(("%s failed with error %d: %s", funct, dw, lpMsgBuf));

	LocalFree(lpMsgBuf); 
}

const char *winsockerror(
			 IN              u_int32_t e)
{
	const char *s = UnKnown;
	switch (e) {
		CASE_SETSTR(WSAEINTR)
		CASE_SETSTR(WSAEACCES)
		CASE_SETSTR(WSAEFAULT)
		CASE_SETSTR(WSAEINVAL)
		CASE_SETSTR(WSAEMFILE)
		CASE_SETSTR(WSAEWOULDBLOCK)
		CASE_SETSTR(WSAEINPROGRESS)
		CASE_SETSTR(WSAEALREADY)
		CASE_SETSTR(WSAENOTSOCK)
		CASE_SETSTR(WSAEDESTADDRREQ)
		CASE_SETSTR(WSAEMSGSIZE)
		CASE_SETSTR(WSAEPROTOTYPE)
		CASE_SETSTR(WSAENOPROTOOPT)
		CASE_SETSTR(WSAEPROTONOSUPPORT)
		CASE_SETSTR(WSAESOCKTNOSUPPORT)
		CASE_SETSTR(WSAEOPNOTSUPP)
		CASE_SETSTR(WSAEPFNOSUPPORT)
		CASE_SETSTR(WSAEAFNOSUPPORT)
		CASE_SETSTR(WSAEADDRINUSE)
		CASE_SETSTR(WSAEADDRNOTAVAIL)
		CASE_SETSTR(WSAENETDOWN)
		CASE_SETSTR(WSAENETUNREACH)
		CASE_SETSTR(WSAENETRESET)
		CASE_SETSTR(WSAECONNABORTED)
		CASE_SETSTR(WSAECONNRESET)
		CASE_SETSTR(WSAENOBUFS)
		CASE_SETSTR(WSAEISCONN)
		CASE_SETSTR(WSAENOTCONN)
		CASE_SETSTR(WSAESHUTDOWN)
		CASE_SETSTR(WSAETIMEDOUT)
		CASE_SETSTR(WSAECONNREFUSED)
		CASE_SETSTR(WSAEHOSTDOWN)
		CASE_SETSTR(WSAEHOSTUNREACH)
		CASE_SETSTR(WSAEPROCLIM)
		CASE_SETSTR(WSASYSNOTREADY)
		CASE_SETSTR(WSAVERNOTSUPPORTED)
		CASE_SETSTR(WSANOTINITIALISED)
		CASE_SETSTR(WSAEDISCON)
		CASE_SETSTR(WSATYPE_NOT_FOUND)
		CASE_SETSTR(WSAHOST_NOT_FOUND)
		CASE_SETSTR(WSATRY_AGAIN)
		CASE_SETSTR(WSANO_RECOVERY)
		CASE_SETSTR(WSANO_DATA)
		CASE_SETSTR(WSA_IO_INCOMPLETE)
		CASE_SETSTR(WSA_IO_PENDING)
		CASE_SETSTR(WSA_NOT_ENOUGH_MEMORY)
		CASE_SETSTR(WSA_OPERATION_ABORTED)
		CASE_SETSTR(WSASYSCALLFAILURE)
		default:   ;
	}
	return s;
} 

void set_buffer_data(
	IN	char* buf,
	IN	int len,
	IN	char val)
{
	int i;

	for (i = 0; i < len; ++i) {
		buf[i] = val;
	}
}

int validate_buffer_data(
	IN	char* buf,
	IN	int len,
	IN	char comp)
{
	int last_error = 0;
	int i;

	for (i = 1; i < len; ++i) {
		CHECK_VALUE("validate", buf[i], comp, return i);
	}
	return 0;
}